using UnityEngine;
using System.Collections;

public class GlobalBehaviour3 : MonoBehaviour {

	public Transform cellPrefab;
	public Vector3 recentSpawn;
	private bool[,] next;
	private Transform[,] objs;
	private int counter = 0;
	// Use this for initialization
	void Start () {
		/*var initial = new int[3, 7]{
			{ 0, 1, 0, 0, 0, 0, 0 },
			{ 0, 0, 0, 1, 0, 0, 0 },
			{ 1, 1, 0, 0, 1, 1, 1 },
		};*/
		var initial = new int[11, 38] {
			{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0},
			{0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0},
			{0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,1,0,1,1,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
		};
		next = new bool[initial.GetLength(0), initial.GetLength(1)];
		objs = new Transform[initial.GetLength(0), initial.GetLength(1)];
		
		for(int i = 0; i < initial.GetLength(0); i++) {
			for(int j = 0; j < initial.GetLength(1); j++) {
				Transform obj = (Transform)Instantiate(cellPrefab, new Vector3(j-(initial.GetLength(1)/2), 0.5f, i-(initial.GetLength(0))), Quaternion.identity);
				Renderer ren = obj.GetComponent<Renderer>();
				next[i,j] = ren.enabled = (initial[i, j] == 1);
				objs[i,j] = obj;
			}
		}
	}

	// Update is called once per frame
	void Update () {
		if(counter < 60) {
			counter++;
			return;
		}
		else counter = 0;
		for(int i = 0; i < objs.GetLength(0); i++) {
			for(int j = 0; j < objs.GetLength(1); j++) {
				Renderer ren = objs[i,j].GetComponent<Renderer>();
				int neiborNum = 0;
				if(0 <= j+1 && j+1 < objs.GetLength(1)) {
					if(objs[i,j+1].GetComponent<Renderer>().enabled) neiborNum++;
					if(0 <= i+1 && i+1 < objs.GetLength(0)) {
						if(objs[i+1,j+1].GetComponent<Renderer>().enabled) neiborNum++;
					}
					if(0 <= i-1 && i-1 < objs.GetLength(0)) {
						if(objs[i-1,j+1].GetComponent<Renderer>().enabled) neiborNum++;
					}
				}
				if(0 <= j-1 && j-1 < objs.GetLength(1)) {
					if(objs[i,j-1].GetComponent<Renderer>().enabled) neiborNum++;
					if(0 <= i+1 && i+1 < objs.GetLength(0)) {
						if(objs[i+1,j-1].GetComponent<Renderer>().enabled) neiborNum++;
					}
					if(0 <= i-1 && i-1 < objs.GetLength(0)) {
						if(objs[i-1,j-1].GetComponent<Renderer>().enabled) neiborNum++;
					}
				}
				if(0 <= i+1 && i+1 < objs.GetLength(0)) {
					if(objs[i+1,j].GetComponent<Renderer>().enabled) neiborNum++;
				}
				if(0 <= i-1 && i-1 < objs.GetLength(0)) {
					if(objs[i-1,j].GetComponent<Renderer>().enabled) neiborNum++;
				}
				if(ren.enabled) {
					if(neiborNum < 2 || neiborNum > 3) next[i,j] = false;
				}
				else {
					if(neiborNum == 3) next[i,j] = true;
				}
			}
		}
		for(int i = 0; i < objs.GetLength(0); i++) {
			for(int j = 0; j < objs.GetLength(1); j++) {
				objs[i,j].GetComponent<Renderer>().enabled = next[i,j];
			}
		}
	}
}
